import {IActionOptions} from './components/actions/Action';
import {IActionBarState} from './components/actions/ActionBarReducers';
import {IItemFilterState} from './components/actions/filters/ItemFilterReducers';
import {IAutocompleteState} from './components/autocomplete/AutocompleteReducers';
import {ICheckboxState} from './components/checkbox/CheckboxReducers';
import {IGroupableCheckboxesState} from './components/checkbox/GroupableCheckboxReducers';
import {CollapsibleState} from './components/collapsible/CollapsibleReducers';
import {IDatePickerState} from './components/datePicker/DatePickerReducers';
import {IDropdownState} from './components/dropdown/DropdownReducers';
import {IDropdownOption} from './components/dropdownSearch/DropdownSearch';
import {IDropdownSearchState} from './components/dropdownSearch/DropdownSearchReducers';
import {IFacet} from './components/facets/Facet';
import {IFacetState} from './components/facets/FacetReducers';
import {IFilterState} from './components/filterBox/FilterBoxReducers';
import {IFlatSelectState} from './components/flatSelect/FlatSelectReducers';
import {IFlippableState} from './components/flippable/FlippableReducers';
import {IInlinePromptOptions} from './components/inlinePrompt/InlinePrompt';
import {IPromptState} from './components/inlinePrompt/InlinePromptReducers';
import {IInputState} from './components/input/InputReducers';
import {ILastUpdatedState} from './components/lastUpdated/LastUpdatedReducers';
import {IListBoxState} from './components/listBox/ListBoxReducers';
import {ILoadingState} from './components/loading/LoadingReducers';
import {IMenusState} from './components/menu/MenuReducers';
import {IModalState} from './components/modal/ModalReducers';
import {IPaginationState} from './components/navigation/pagination/NavigationPaginationReducers';
import {IPerPageState} from './components/navigation/perPage/NavigationPerPageReducers';
import {IOptionPickerState} from './components/optionPicker/OptionPickerReducers';
import {IOptionsCycleState} from './components/optionsCycle/OptionsCycleReducers';
import {ISearchBarState} from './components/searchBar/SearchBarReducers';
import {ISelectState} from './components/select/SelectReducers';
import {ISubNavigationState} from './components/subNavigation/SubNavigationReducers';
import {ITabGroupState} from './components/tab/TabReducers';
import {ITablePredicate} from './components/tables/Table';
import {ITableStateModifier} from './components/tables/TableActions';
import {ITableHeaderCellsState} from './components/tables/TableHeaderCellReducers';
import {ITableData, ITablesState} from './components/tables/TableReducers';
import {ITableRowState} from './components/tables/TableRowReducers';
import {ITextAreaState} from './components/textarea/TextAreaReducers';
import {IToastsState} from './components/toast/ToastReducers';

export interface IReactVaporState {
    autocompletes: IAutocompleteState[];
    lastUpdatedComposite?: ILastUpdatedState[];
    facets?: IFacetState[];
    filters?: IFilterState[];
    perPageComposite?: IPerPageState[];
    paginationComposite?: IPaginationState[];
    loadings?: ILoadingState[];
    listBoxes?: IListBoxState[];
    selects?: ISelectState[];
    prompts?: IPromptState[];
    actionBars?: IActionBarState[];
    dropdowns?: IDropdownState[];
    dropdownSearch?: IDropdownSearchState[];
    flatSelect?: IFlatSelectState[];
    rows?: ITableRowState[];
    optionsCycles?: IOptionsCycleState[];
    datePickers?: IDatePickerState[];
    optionPickers?: IOptionPickerState[];
    itemFilters?: IItemFilterState[];
    modals?: IModalState[];
    openModals?: string[];
    subNavigations?: ISubNavigationState[];
    tabs?: ITabGroupState[];
    toastContainers?: IToastsState[];
    tableHeaderCells?: ITableHeaderCellsState;
    tables?: ITablesState;
    checkboxes?: ICheckboxState[];
    inputs?: IInputState[];
    collapsibles?: CollapsibleState[];
    searchBars?: ISearchBarState[];
    flippables?: IFlippableState[];
    groupableCheckboxes?: IGroupableCheckboxesState[];
    textAreas?: ITextAreaState[];
    menus?: IMenusState;
}

export interface IReduxActionsPayload {
    id?: string;
    ids?: string[];
    isCollapsible?: boolean;
    facet?: string;
    facetRow?: IFacet;
    filterText?: string;
    pageNb?: number;
    perPage?: number;
    options?: IInlinePromptOptions;
    actions?: IActionOptions[];
    currentOption?: number;
    color?: string;
    date?: Date;
    calendarId?: string;
    value?: string;
    isRange?: boolean;
    limit?: string;
    item?: string;
    label?: string;
    selected?: string;
    tableId?: string;
    isInError?: boolean;
    attributeToFormat?: string;
    attributeToSort?: string;
    initialTableData?: ITableData;
    initialPerPage?: number;
    tableStateModifier?: ITableStateModifier;
    totalEntries?: number;
    totalPages?: number;
    addedSelectedOption?: IDropdownOption;
    predicates?: ITablePredicate[];
    shouldResetPage?: boolean;
    valid?: boolean;
    expanded?: boolean;
    disabled?: boolean;
    searching?: boolean;
    yPosition?: number;
}
