import * as React from 'react';
import {TabConnected} from '../TabConnected';
import {TabContent} from '../TabContent';
import {TabNavigation} from '../TabNavigation';
import {TabPaneConnected} from '../TabPaneConnected';

const TAB1_ID = 'tab1';
const TAB2_ID = 'tab2';
const TAB3_ID = 'tab3';

export class TabsExamples extends React.Component<any, any> {

    render() {
        return (
            <div className='mt2'>
                <div className='form-group'>
                    <label className='form-control-label'>Tabs</label>
                    <div>
                        <TabNavigation>
                            <TabConnected id={TAB1_ID} title='A Tab' />
                            <TabConnected id={TAB2_ID} title='Another Tab' />
                            <TabConnected id={TAB3_ID} title='Yet Another Tab' />
                        </TabNavigation>
                        <TabContent>
                            <TabPaneConnected id={TAB1_ID}>
                                <div className='mod-header-padding mod-form-top-bottom-padding'>
                                    Content of the first tab.
                </div>
                            </TabPaneConnected>
                            <TabPaneConnected id={TAB2_ID}>
                                <div className='mod-header-padding mod-form-top-bottom-padding'>
                                    Content of the second tab.
                </div>
                            </TabPaneConnected>
                            <TabPaneConnected id={TAB3_ID}>
                                <div className='mod-header-padding mod-form-top-bottom-padding'>
                                    Last tab.
                </div>
                            </TabPaneConnected>
                        </TabContent>
                    </div>
                </div>
            </div>
        );
    }
}
